#include "defines.h"
#include "interrupt.h"
#include "intr.h"
#include "cm0scs.h"

/* $B3d$j9~$_%3%s%H%m!<%i$N=i4|2=(B */
void intc_init(void)
{
  *(volatile uint32 *)NVIC_ICER = ~0;     /* $BA4$F$N3d$j9~$_$r6X;_(B */
  *(volatile uint32 *)NVIC_ICPR = ~0;     /* $BA4$F$N3d$j9~$_MW0x$r%/%j%"(B */
  // $B3d$j9~$_M%@h=g0L$O=i4|CM$N$^$^$H$9$k(B
}

/* $B3d$j9~$_MW0x$N5v2D(B */
void intc_enable(softvec_type_t type)
{
  *(volatile uint32 *)NVIC_ISER = 1 << (type & 0x1f);
}

/* $B3d$j9~$_MW0x$N6X;_(B */
void intc_disable(softvec_type_t type)
{
  *(volatile uint32 *)NVIC_ICER = 1 << (type & 0x1f);
}

/* $B3d$j9~$_MW0x$N%/%j%"(B */
void intc_clear(softvec_type_t type)
{
  *(volatile uint32 *)NVIC_ICPR = 1 << (type & 0x1f);
}
